!
subroutine LA44(Amv, B, X, Max, Error)
!    
!  .
! .     .
interface
  subroutine Amv(V,AV)
    real, intent(in):: V(:)
    real:: AV(:)
  end subroutine Amv
end interface
real, intent(in):: B(:)
real, intent(inout):: X(:)
integer, intent(inout):: Max
integer:: Error
real, allocatable:: R(:), S(:), AS(:)
real RN, RR, RRold, Ass, Omega, Sigma, F, F2, Alpha, Beta
integer i, k, sqn, ksqn, n
!begin
  Error=0
  n=size(B)
  allocate(R(N), S(n), AS(n))
  RN=float(n)
  sqn=int(sqrt(RN)); ksqn=sqn
  Omega=1.0
  F=exp(1.0/RN); F2=F*F
  if (Max<0) then
    Max=-Max; X=0.0
  endif
  call Amv(X, AS)
  do i=1,n
    R(i)=AS(i)-B(i); S(i)=R(i)
  end do
  RR=SP(R,R)
  do k=1, Max
    if (k==ksqn) then
      ksqn=ksqn+sqn
      Omega=Omega*F; F=F*F2
      call Amv(X,AS)
      Sigma=0.0
      do i=1,n
        Sigma=Sigma+(AS(i)-B(i)-R(i))**2
      end do
      Sigma=Omega*Sigma
    end if
    call Amv(S,AS)
    Ass=SP(S,AS)
    if (RN+Ass==RN) then
      deallocate(R, S, AS)
      Max=k; Error=65; return
    end if
    Alpha=RR/Ass
    do i=1,n
      R(i)=R(i)-Alpha*AS(i)
      X(i)=X(i)-Alpha*S(i)
    end do
    RRold=RR; RR=SP(R,R)
    if (RR<Sigma) then
      Max=k; return
    end if
    Beta=RR/RRold
    do i=1,n; S(i)=R(i)+Beta*S(i); end do
  end do
  deallocate(R, S, AS)
  Error=1; return

contains

real function SP(U, V)
real, intent(in):: U(:), V(:)
double precision S
integer i, n
!begin
  n=size(U)
  S=0.D0
  do i=1,n
    S=S+U(i)*dble(V(i))
  end do
  SP=sngl(S)
  return
end function SP

end subroutine LA44
